# DestinE utils

Collection of scripts to deploy, run and analyze the performance of the IFS-NEMO

- [DestinE utils](#destine-utils)
  - [Requeriments](#requeriments)
  - [Versions](#versions)
  - [Installation](#installation)
    - [MN5 Deployment](#mn5-deployment)
  - [Running](#running)
  - [Performance](#performance)


## Requeriments

* ECMWF Git account and SSH connection on your workstaion.
* Have MN5 transfer nodes in the ssh configuration of your workstaion.
* Clone this repo in your local machine & MN5

## Versions
Scrip to generate a file with the version (repo, branch and commit hash)
of each component of the IFS-BUNDLE.
```bash
Usage: ./check_ifs_bundle_version.sh <ifs-bundle-dir>
```
## Installation
Currently, only MN5 is supported by this scripts.

### MN5 Deployment

Follow the instructions below to install the model "by hand". Remember that 
we need to copy the sources to MN5 from your workstation and then 
submit the compilation. Check the environment file for MN5 in order to
select the working RAPS, IFS-SOURCE and IFS-BUNDLE:

```bash
# RAPS: Responsible vcorreal
export IFS_BUNDLE_RAPS_GIT="ssh://git@git.ecmwf.int/~esp0512/raps-optimizations.git"
export IFS_BUNDLE_RAPS_VERSION="features/mn5"
# IFS-SOURCE: Responsible cpena
export IFS_BUNDLE_IFS_SOURCE_GIT="ssh://git@git.ecmwf.int/~pacp/ifs-source-de.git"
export IFS_BUNDLE_IFS_SOURCE_VERSION="MN5"
# This skips the downloading of the ORCA grids during the compilation (need at MN5)
export IFS_BUNDLE_ATLAS_ORCA_CMAKE="ENABLE_RETRIEVE_ORCA_DATA=OFF ENABLE_INSTALL_ORCA_DATA=OFF"

```

> It is pending to get all this changes pushed into a stable
> IFS-Bundle tag

1. Using your local machine, go to `installation/ifs-bundle` path.
2. Execute `clone_sources.sh`. You need to select the ifs-bundle repository 
with `--repo`.

> You can select the desired branch of the repo with --branch and a 
> bundle environment with --bundle-env.

3. By default, the name of the installation is the repo name followed by the 
branch name and the commit hash. You can select another name with `--name`.

4. Select the MN5 path to move the sources with `--mn5-dir`, using the
syntax: `mn5-transfer1:/your/desired/path`

5. A prompt will resume all the choices before submit the start of the process.

6. Open a terminal to MN5 login node and go to `installation/ifs-bundle`.

7. Once you have the sources in MN5, you can submit the compilation in two ways
using the same `compile-mn5-gpp.slurm` script. This script requires two 
positional arguments, first the root of your ifs-bundle (`--mn5-dir` parameter)
and second the arch (is optional, by default it uses 
the `arch/eurohpc/mn5-gpp/default`):

    ```bash
    # Interactive compilation
    bash compile-mn5-gpp.slurm /gpfs/projects/bsc32/DestinE/models/ifs-nemo/perfomance [arch file]
    # SLURM compilation 
    sbatch --qos <your_queue> compile-mn5-gpp.slurm /gpfs/projects/bsc32/DestinE/models/ifs-nemo/perfomance [arch file]
    ```

The following code fence show a complete example:
````bash
# LOCAL MACHINE (WITH ECMWF GIT SSH CONFIGURED), at destine-utils/installation

./clone_sources.sh --repo ssh://git@git.ecmwf.int/~esp0512/ifs-bundle-performance.git \
  --branch feature/mn5 \
  --mn5-dir mn5-transfer1:/gpfs/projects/bsc32/DestinE/models/ifs-nemo/perfomance \
  --bundle-env mn5-gpp-env 

# AT MN5 login node (any login node), at destine-utils/installation
sbatch --qos <your_queue> \
  compile-mn5-gpp.slurm /gpfs/projects/bsc32/DestinE/models/ifs-nemo/perfomance

````
## Running


## Performance
